﻿using System;
using System.ComponentModel;
using System.Net;
using System.Runtime.InteropServices;
using System.Security.Policy;
using System.Web;
using System.Windows.Forms;
using AddinExpress.RTD;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace ExcelStockInfo
{
    /// <summary>
    ///   Add-in Express RTD Server Module
    /// </summary>
    [GuidAttribute("E70420E6-676C-4485-8A96-F14BE24B3F24"), ProgId("ExcelStockInfo.RTDServerModule")]
    public class RTDServerModule : AddinExpress.RTD.ADXRTDServerModule
    {
        public RTDServerModule()
        {
            InitializeComponent();
            // Please add any initialization code to the RTDInitialize event handler
        }

        private ADXRTDTopic rtdTopicQuotes;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.rtdTopicQuotes = new AddinExpress.RTD.ADXRTDTopic(this.components);
            // 
            // rtdTopicQuotes
            // 
            this.rtdTopicQuotes.String01 = "*";
            this.rtdTopicQuotes.String02 = "*";
            this.rtdTopicQuotes.Tag = "";
            this.rtdTopicQuotes.UseStoredValue = true;
            this.rtdTopicQuotes.RefreshData += new AddinExpress.RTD.ADXRefreshData_EventHandler(this.adxrtdTopic1_RefreshData);
            // 
            // RTDServerModule
            // 
            this.Interval = 600000;

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void RTDServerRegister(Type t)
        {
            AddinExpress.RTD.ADXRTDServerModule.ADXRTDServerRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void RTDServerUnregister(Type t)
        {
            AddinExpress.RTD.ADXRTDServerModule.ADXRTDServerUnregister(t);
        }

        #endregion

        public static new RTDServerModule CurrentInstance
        {
            get
            {
                return AddinExpress.RTD.ADXRTDServerModule.CurrentInstance as RTDServerModule;
            }
        }

        private object adxrtdTopic1_RefreshData(object sender)
        {
            if (sender is ADXRTDTopic)
            {
                ADXRTDTopic topic = sender as ADXRTDTopic;
                string symbol = topic.String01;
                string fieldName = topic.String02;
                return GetValue(symbol, fieldName);
            }
            return default(object);
        }

        private string GetValue(string symbol, string field)
        {
            string json = HttpGet(symbol, field);
            dynamic obj = JsonConvert.DeserializeObject(json);
            var quote = obj.query.results.quote;

            JToken returnValue = null;
            quote.TryGetValue(field, out returnValue);
            if (returnValue != null)
                return returnValue.Value<string>();

            return field + " is not a valid field name.";
        }

        private string HttpGet(string symbol, string field)
        {
            string uri = string.Format("http://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20yahoo.finance.quotes%20where%20symbol=%22{0}%22&format=json&env=store%3A%2F%2Fdatatables.org%2Falltableswithkeys", symbol);

            var req = WebRequest.Create(uri);
            var resp = req.GetResponse();
            var sr = new System.IO.StreamReader(resp.GetResponseStream());
            return sr.ReadToEnd().Trim();
        }
    }
}

